Index: docs/sphinx-docs/source/conf.py
===================================================================
--- docs/sphinx-docs/source/conf.py	(revision 9e78edbbda1fd23345bf69282aaf9540d5002ad5)
+++ docs/sphinx-docs/source/conf.py	(revision 3586bd1c0e50057629d1ad5b0b8b3b0d1444fd4e)
@@ -12,18 +12,10 @@
 # serve to show the default.
 
-import sys, os, collections
+import sys, os
 
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
-from distutils.util import get_platform
-platform = '.%s-%s'%(get_platform(),sys.version[:3])
-build_lib = os.path.abspath('../../../build/lib'+platform)
-sys.path.insert(0, build_lib)
-print "-- path --"
-print "\n".join(sys.path)
-import sans.sansview
-from sans.sansview import __version__ as sasview_version
-print "version:",sasview_version
+sys.path.insert(0, os.path.abspath('../../src'))
 
 # -- General configuration -----------------------------------------------------
@@ -34,9 +26,5 @@
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.autodoc',
-              'sphinx.ext.todo',
-              'sphinx.ext.coverage',
-              'sphinx.ext.mathjax',
-              'sphinx.ext.viewcode']
+extensions = ['sphinx.ext.autodoc', 'sphinx.ext.todo', 'sphinx.ext.coverage', 'sphinx.ext.mathjax', 'sphinx.ext.viewcode']
 
 # Add any paths that contain templates here, relative to this directory.
@@ -77,13 +65,5 @@
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
-#
-# PGP 2014/04/03: We have some code which doesn't get carried over to
-# the build directory.  Exclude the appropriate *.rst files here so
-# that we don't get various "ImportError: No module named ___" when
-# running Sphinx.
-exclude_patterns = ["*sans.perspectives.simulation.rst",
-                    "*sans.pr.c_extensions.rst",
-                    "*sans.realspace.rst",
-                    "*sans.simulation.rst",]
+exclude_patterns = []
 
 # The reST default role (used for this markup: `text`) to use for all documents.
@@ -189,9 +169,4 @@
 # Output file base name for HTML help builder.
 htmlhelp_basename = 'SasViewdoc'
-
-# Turn off permalinks, which are a nice feature for the docs when viewed in a
-# browser, but which look weird (and cannot be "right-click->copy url") in
-# the SasView help.
-html_add_permalinks = ""
 
 
Index: cs/sphinx-docs/source/dev/dev.rst
===================================================================
--- docs/sphinx-docs/source/dev/dev.rst	(revision a40a875e498ab359ff534604b269a95081034b59)
+++ 	(revision )
@@ -1,17 +1,0 @@
-Developer Documentation
-=======================
-
-Contents
---------
-
-.. toctree::
-   :maxdepth: 1
-
-   SasView and Park API <api/modules>
-
-Indices and Search
-------------------
-
-* :ref:`genindex`
-* :ref:`modindex`
-* :ref:`search`
Index: docs/sphinx-docs/source/index.rst
===================================================================
--- docs/sphinx-docs/source/index.rst	(revision a40a875e498ab359ff534604b269a95081034b59)
+++ docs/sphinx-docs/source/index.rst	(revision 3586bd1c0e50057629d1ad5b0b8b3b0d1444fd4e)
@@ -4,11 +4,19 @@
    contain the root `toctree` directive.
 
-SasView Documentation
+SasView documentation
 =====================
 
+Contents:
+
 .. toctree::
-   :maxdepth: 1
+   :maxdepth: 2
 
-   User Documentation <user/user>
 
-   Developer Documentation <dev/dev>
+
+Indices and tables
+==================
+
+* :ref:`genindex`
+* :ref:`modindex`
+* :ref:`search`
+
Index: cs/sphinx-docs/source/user/user.rst
===================================================================
--- docs/sphinx-docs/source/user/user.rst	(revision a40a875e498ab359ff534604b269a95081034b59)
+++ 	(revision )
@@ -1,7 +1,0 @@
-User Documentation
-==================
-
-.. toctree::
-   :maxdepth: 1
-
-   Models <models/model_functions>