Index: sansguiframe/src/sans/guiframe/gui_manager.py
===================================================================
--- sansguiframe/src/sans/guiframe/gui_manager.py	(revision 53f9e408f170c34898d70a62e43598c20e0647bc)
+++ sansguiframe/src/sans/guiframe/gui_manager.py	(revision 3704e338f360f31aa9a474d19d9188d8ea580ea1)
@@ -280,6 +280,4 @@
         # plot duck cleanup option
         self.cleanup_plots = CLEANUP_PLOT
-        # (un)-focus color
-        #self.color = '#b3b3b3'
         ## Find plug-ins
         # Modify this so that we can specify the directory to look into
@@ -627,5 +625,4 @@
                     frame = plugin.get_frame()
                     frame.Show(True)
-                    #self._check_applications_menu()
                     #break
                 else:
@@ -964,6 +961,4 @@
             return panel_width, panel_height
         if hasattr(p, "CENTER_PANE") and p.CENTER_PANE:
-            #style = self.__gui_style & (GUIFRAME.PLOTTING_ON|GUIFRAME.MANAGER_ON)
-            #if style == (GUIFRAME.PLOTTING_ON|GUIFRAME.MANAGER_ON):
             panel_width = self._window_width * 0.45
             if custom_config != None:
@@ -975,5 +970,4 @@
         elif p == self.defaultPanel:
             return self._window_width, panel_height
-        #total_width = panel_width + self._window_width - 2.3 * panel_width
         return panel_width, panel_height
     
@@ -1008,11 +1002,7 @@
         frame.Show(True)
         #add data panel 
-        
-        #w, h = self._get_panels_size(self._data_panel)
         win = MDIFrame(self, None, 'None', (100, 200))
-        #win.EnableCloseButton(False)
         data_panel = DataPanel(parent=win,  id=-1)
         win.set_panel(data_panel)
-        #data_panel.set_frame(win)
         self.panels["data_panel"] = data_panel
         self._data_panel = data_panel
@@ -1145,7 +1135,4 @@
         """
         frame = event.GetEventObject()
-        #panel = frame.panel
-        #if panel.IsMaximized():
-        #    self._mgr.RestoreMaximizedPane()
         for ID in self.plot_panels.keys():
             if self.plot_panels[ID].window_name == frame.name:
@@ -1174,15 +1161,9 @@
         p_panel_height = int(p_panel_width * 0.76)
         p.frame.SetSize((p_panel_width, p_panel_height))
-        """
-        dw, dh = self._get_panels_size(self._data_panel)
-        dw += p_panel_width
-        _, dh = self.GetToolBar().GetSizeTuple()
-        p.frame.SetPosition((dw, -dh))
-        """
         self.graph_num += 1
         if p.window_caption.split()[0] in NOT_SO_GRAPH_LIST:
             windowcaption = p.window_caption
         else:
-            windowcaption = 'Graph'#p.window_caption
+            windowcaption = 'Graph'
         windowname = p.window_name
 
@@ -1200,7 +1181,4 @@
             p.window_caption = caption 
         p.window_name = windowname + str(self.graph_num)
-        
-        #style1 = self.__gui_style & GUIFRAME.FIXED_PANEL
-        #style2 = self.__gui_style & GUIFRAME.FLOATING_PANEL
         
         p.frame.SetTitle(p.window_caption)
@@ -1475,6 +1453,4 @@
         add menu application
         """
-        #style = self.__gui_style & GUIFRAME.MULTIPLE_APPLICATIONS
-        #if style == GUIFRAME.MULTIPLE_APPLICATIONS:
         if self._num_perspectives  > 1:
             plug_data_count = False
@@ -1498,5 +1474,4 @@
                     wx.EVT_MENU(self, id, plug.on_perspective)
 
-            #self._applications_menu.
             if (not plug_data_count or not plug_no_data_count):
                 self._applications_menu.RemoveItem(separator)
@@ -1549,5 +1524,4 @@
             wx.EVT_MENU(self, id, self._on_save_project)
         if style1 == GUIFRAME.MULTIPLE_APPLICATIONS:
-            #self._file_menu.AppendSeparator()
             id = wx.NewId()
             self._save_appl_menu = self._file_menu.Append(id, 
@@ -1688,11 +1662,9 @@
             self.panel_on_focus = None
             panel = self.panels[ID]
-            #self._mgr.DetachPane(panel)
+
             if hasattr(panel, "connect"):
                 panel.connect.disconnect()
             self._plotting_plugin.delete_panel(panel.group_id)
-            #panel.Hide()
-            #panel.clear()
-            #panel.Close()
+
             if panel in self.schedule_full_draw_list:
                 self.schedule_full_draw_list.remove(panel) 
@@ -2070,7 +2042,4 @@
             content = res.read()
             conn.close()
-            #f=urllib2.urlopen(config.__update_URL__, 
-            #                  timeout=1.0)
-            #content = f.read()
         except:
             content = "0.0.0"
@@ -2251,5 +2220,4 @@
         frame = pane.get_frame()
         if label == 'Show Data Explorer':
-            #if not pane.IsShown():
             if action: 
                 frame.Show(True)
@@ -2629,5 +2597,4 @@
             if data.dqy_data != None: 
                 dy_val = data.dqy_data[index]
-            #if data.mask != None: mask_val = data.mask[index] 
   
             text += "%s \t%s \t%s \t%s \t%s \t%s \t%s\n" % (index,
@@ -2761,6 +2728,5 @@
             flag = self.cpanel_on_focus.get_paste_flag()
             self._edit_menu.Enable(GUIFRAME_ID.PASTE_ID, flag)
-            #flag = self.cpanel_on_focus.get_print_flag()
-            #self._edit_menu.Enable(GUIFRAME_ID.PRINT_ID, flag)
+
             flag = self.cpanel_on_focus.get_preview_flag()
             self._edit_menu.Enable(GUIFRAME_ID.PREVIEW_ID, flag)
@@ -2773,5 +2739,5 @@
             self._edit_menu.Enable(GUIFRAME_ID.COPY_ID, flag)
             self._edit_menu.Enable(GUIFRAME_ID.PASTE_ID, flag)
-            #self._edit_menu.Enable(GUIFRAME_ID.PRINT_ID, flag)
+
             self._edit_menu.Enable(GUIFRAME_ID.PREVIEW_ID, flag)
             self._edit_menu.Enable(GUIFRAME_ID.RESET_ID, flag)
@@ -3014,6 +2980,5 @@
         drag 
         """
-        #if self.cpanel_on_focus is not None:
-        #    self._toolbar.enable_drag(self.panel_on_focus)
+        #Not implemeted
             
     def enable_reset(self):
@@ -3100,7 +3065,9 @@
                 raise
      
-        # Draw all panels        
-        #map(f_draw, self.schedule_full_draw_list)
-        f_draw(self.schedule_full_draw_list[0])
+        # Draw all panels 
+        if count == 1:
+            f_draw(self.schedule_full_draw_list[0])  
+        else:
+            map(f_draw, self.schedule_full_draw_list)
         # Reset the attr  
         if len(self.schedule_full_draw_list) == 0:
@@ -3234,7 +3201,5 @@
             logging.error(msg)
             self.frame.Show()
- 
-        #if hasattr(self.frame, 'special'):
-        #    self.frame.special.SetCurrent()
+
         self.SetTopWindow(self.frame)
   
@@ -3309,6 +3274,4 @@
             raise
         self.frame.build_gui()
-        #if self.s_screen is not None and self.s_screen.IsShown():
-        #    self.s_screen.Close()
         
     def set_welcome_panel(self, panel_class):