Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision cc316087447594027dc1ee6e8fb72cb75f171858)
+++ sansview/perspectives/fitting/basepage.py	(revision 4225aed07c68c499b94bed34645ed31e375b389e)
@@ -68,4 +68,7 @@
         self.mask = None
         self.uid = None
+        #Q range for data set
+        self.qmin_data_set = None
+        self.qmax_data_set = None
         ## Q range
         self.qmin = None
Index: sansview/perspectives/fitting/fitpage.py
===================================================================
--- sansview/perspectives/fitting/fitpage.py	(revision 75daa79c63b58805f733f344a44aae6d3234fafa)
+++ sansview/perspectives/fitting/fitpage.py	(revision 4225aed07c68c499b94bed34645ed31e375b389e)
@@ -97,7 +97,13 @@
         self.data_list = data_list
         self.enable_datasource()
+        if data_list:
+            qmin, qmax, _ = self.compute_data_range(data_list[0])
+            self.qmin_data_set, self.qmax_data_set = qmin, qmax
         for data in self.data_list:
             if data is not None:
+                self.compute_data_set_range(data)
                 self.dataSource.Append(str(data.name), clientData=data)
+                
+        print "fill_data_combox", self.qmin_data_set, self.qmax_data_set
         self.dataSource.SetSelection(0)
         self.on_select_data(event=None)
@@ -292,14 +298,22 @@
         # StaticText for smear
         #self.tcChi    =  wx.StaticText(self, -1, "-", style=wx.ALIGN_LEFT)
-        self.smear_description_none    =  wx.StaticText(self, -1, smear_message_none , style=wx.ALIGN_LEFT)
-        self.smear_description_dqdata    =  wx.StaticText(self, -1, smear_message_dqdata , style=wx.ALIGN_LEFT)
-        self.smear_description_type    =  wx.StaticText(self, -1, "Type:" , style=wx.ALIGN_LEFT)
-        self.smear_description_accuracy_type    =  wx.StaticText(self, -1, "Accuracy:" , style=wx.ALIGN_LEFT)
-        self.smear_description_smear_type    =  BGTextCtrl(self, -1, size=(57,20), style=0)
+        self.smear_description_none =  wx.StaticText(self, -1, 
+                                    smear_message_none , style=wx.ALIGN_LEFT)
+        self.smear_description_dqdata =  wx.StaticText(self, 
+                                -1, smear_message_dqdata , style=wx.ALIGN_LEFT)
+        self.smear_description_type =  wx.StaticText(self,
+                                     -1, "Type:" , style=wx.ALIGN_LEFT)
+        self.smear_description_accuracy_type =  wx.StaticText(self, -1, 
+                                        "Accuracy:" , style=wx.ALIGN_LEFT)
+        self.smear_description_smear_type =  BGTextCtrl(self, -1, 
+                                                        size=(57,20), style=0)
         self.smear_description_smear_type.SetValue(str(self.dq_l))
         self.SetBackgroundColour(self.GetParent().GetBackgroundColour())
-        self.smear_description_2d     =  wx.StaticText(self, -1, smear_message_2d  , style=wx.ALIGN_LEFT)
-        self.smear_message_new_s = wx.StaticText(self, -1, smear_message_new_ssmear  , style=wx.ALIGN_LEFT)
-        self.smear_message_new_p = wx.StaticText(self, -1, smear_message_new_psmear  , style=wx.ALIGN_LEFT)
+        self.smear_description_2d =  wx.StaticText(self, -1, 
+                                    smear_message_2d  , style=wx.ALIGN_LEFT)
+        self.smear_message_new_s = wx.StaticText(self, -1,
+                         smear_message_new_ssmear, style=wx.ALIGN_LEFT)
+        self.smear_message_new_p = wx.StaticText(self, -1,
+                                 smear_message_new_psmear , style=wx.ALIGN_LEFT)
         self.smear_description_2d_x     =  wx.StaticText(self, -1, smear_message_2d_x_title  , style=wx.ALIGN_LEFT)
         self.smear_description_2d_x.SetToolTipString("  dQp(parallel) in q_r direction.")
@@ -464,5 +478,6 @@
         self.model_view.SetToolTipString(hint)
       
-        self.shape_rbutton = wx.RadioButton(self, -1, 'Shapes', style=wx.RB_GROUP)
+        self.shape_rbutton = wx.RadioButton(self, -1, 'Shapes',
+                                             style=wx.RB_GROUP)
         self.shape_indep_rbutton = wx.RadioButton(self, -1, "Shape-Independent")
         self.struct_rbutton = wx.RadioButton(self, -1, "Structure Factor ")
@@ -1627,4 +1642,15 @@
         return self.enable2D
     
+    def compute_data_set_range(self, data):
+        """
+        find the range that include all data  in the set
+        return the minimum and the maximum values
+        """
+        if data is not None:
+            qmin, qmax, _ = self.compute_data_range(data)
+            self.qmin_data_set = min(self.qmin_data_set, qmin)
+            self.qmax_data_set = max(self.qmax_data_set, qmax)
+        
+        
     def compute_data_range(self, data):
         """
@@ -1647,4 +1673,5 @@
                 qmax = math.sqrt(x*x + y*y)
                 npts = len(data.data)
+        print "compute single data range", qmin, qmax
         return qmin, qmax, npts
             
Index: sansview/perspectives/fitting/fitpanel.py
===================================================================
--- sansview/perspectives/fitting/fitpanel.py	(revision 3f36675d749c00f48dfc7b848b879562b4a1b24c)
+++ sansview/perspectives/fitting/fitpanel.py	(revision 4225aed07c68c499b94bed34645ed31e375b389e)
@@ -385,4 +385,5 @@
         data_1d_list = []
         data_2d_list = []
+        # separate data into data1d and data2d list
         for data in data_list:
             if data.__class__.__name__ == "Data1D":